<?php
if (!$UserID = getUserID($db))
{
  return NOT_LOGGED_IN;
}

$ret             = array();
$ret['filename'] = 'profile.tpl';
$ret['data']     = array();

switch (@ $_POST['formaction'])
{
  default :
    $sql = 'SELECT
             Username,Email
            FROM
             User
            WHERE
             ID = ?';

    $stmt = $db->prepare($sql);
    if (!$stmt)
    {
      return $db->error;
    }

    $stmt->bind_param('i', $UserID);

    if (!$stmt->execute())
    {
      return $stmt->error;
    }

    $stmt->bind_result($Username, $Email);
    $stmt->fetch();
    $stmt->close();

    $ret['data']['Username'] = $Username;
    $ret['data']['Email']    = $Email;
    break;

    case 'Profil speichern' :
      if (!isset ($_POST['Username'], $_POST['Email']))
      {
        return INVALID_FORM;
      }
      if (($Username = trim($_POST['Username'])) == '' OR ($Email = trim($_POST['Email'])) == '')
      {
        return EMPTY_FORM;
      }
      if (!preg_match('~\A\S{3,30}\z~', $Username))
      {
        return 'Der Benutzername darf nur aus 3 bis 30 Zeichen bestehen und ' . 'keine Leerzeichen enthalten.';
      }

      $sql = 'SELECT
               ID
              FROM
               User
              WHERE
               Username = ? AND ID != ?';

      // das "ID != ?" dient dazu das wir nicht unseren eigenen Benutzernamen
      // finden sondern nur die der anderen.
      $stmt = $db->prepare($sql);
      if (!$stmt)
      {
        return $db->error;
      }

      $stmt->bind_param('si', $Username, $UserID);
      if (!$stmt->execute())
      {
        return $stmt->error;
      }

      $stmt->bind_result($OtherID);
      $stmt->fetch();
      $stmt->close();

      if ($OtherID)
      {
        return 'Es gibt bereits ein Benutzer der diesen Namen verwendet.';
      }

      if ($OtherID)
      {
        return 'Es gibt bereits ein Benutzer der diesen Namen verwendet.';
      }

      $sql = 'UPDATE
               User
              SET
               Username = ?, Email = ?
              WHERE
               ID = ?';
      $stmt = $db->prepare($sql);

      if (!$stmt)
      {
        return $db->error;
      }
      $stmt->bind_param('ssi', $Username, $Email, $UserID);

      if (!$stmt->execute())
      {
        return $stmt->error;
      }

      return showInfo('Der Benutzername und die Email wurde aktuallisiert.');
      break;

    case 'Password ändern' :
      if (!isset ($_POST['Old'], $_POST['Password']))
      {
        return INVALID_FORM;
      }

      if (!is_array($_POST['Password']) OR count($_POST['Password']) != 2)
      {
        return INVALID_FORM;
      }

      if ($_POST['Password'][0] != $_POST['Password'][1])
      {
        return 'Bitte geben sie das gleiche Password ein.';
      }

      if (($Old = trim($_POST['Old'])) == '' OR ($Password = trim($_POST['Password'][0])) == '')
      {
        return EMPTY_FORM;
      }

      $sql = 'SELECT
               ID
              FROM
               User
              WHERE
               ID = ? AND Password = ?';

      $stmt = $db->prepare($sql);
      if (!$stmt)
      {
        return $db->error;
      }

      $Hash = md5(md5($UserID) . $Old);
      $stmt->bind_param('is', $UserID, $Hash);

      if (!$stmt->execute())
      {
        return $stmt->error;
      }

      if (!$stmt->fetch())
      {
        return 'Das eingegebene Password ist ungültig.';
      }
      $stmt->close();

      $sql = 'UPDATE
               User
              SET
               Password = ?
              WHERE
               ID = ?';

      $stmt = $db->prepare($sql);

      if (!$stmt)
      {
        return $db->error;
      }

      $Hash = md5(md5($UserID) . $Password);
      $stmt->bind_param('si', $Hash, $UserID);

      if (!$stmt->execute())
      {
        return $stmt->error;
      }

      setcookie('UserID', '', strtotime('-1 day'));
      setcookie('Password', '', strtotime('-1 day'));
      unset ($_COOKIE['Username']);
      unset ($_COOKIE['Password']);
      
      return showInfo('Das Password wurde geändert. Sie wurden automatisch ausgeloggt und müssen ' . 'sich ggf. neu einloggen.');
      break;
}
return $ret;
?>